unit myutils;


interface

uses SysUtils, Classes;

var
  myfile: textfile;

  //Czyta i zapisuje pojedyncza linie pliku
  //!! Przed uzyciem - assign(myfile,' nazwa') reset(myfile)

function myfile_rdln(encoding: byte): string;
procedure myfile_wrln(str: string; encoding: byte);

//Wybiera argument z ciagu argumentow rozdzielonych seperatorem
function myGetnArg(argumenty: string; numer: integer; seperator: char): string;

//systemowe
function filename2dir(filename: string): string;
procedure file_copy(plik1, plik2: string);
function file_create(plik: string): boolean;

//testy
function test_nip(nip: string): boolean;
function test_nipr(nipr: string): boolean;
function test_pesel(pesel: string): boolean;
function test_kodpocz(kodpocz: string): boolean;
function test_float(s: string): boolean;
function test_int(s: string): boolean;

//Lancuchowe
function str_upcase(str: string): string;
function str_nbespace(slowo: string): string;
function str_delchar(s: string; a: char): string;
function str_repchar(s: string; a1, a2: char): string;
function str_repstr(str, strco, strczym: string): string;
function str_alignr(s: string; dl: byte; dop: char): string;
function str_findnchar(znak: char; n: byte; slowo: string): byte;
function str_toreal(s: string): currency;
function str_toint(s: string): integer;
function str_fromint(i: integer; lpoz: byte): string;
function str_tobool(s: string): boolean;
function str_pl2ps(s: string): string;
function str_win2lin(win: string): string;
function str_lin2win(lin: string): string;
function str_encode(str: string; encoding: byte): string;

//Daty
function data_getdmr: string;
function data_getrmd: string;
function data_mscname(msc: byte): string;

//liczbowe
function potega(liczba, potega: word): word;
function zaokraglij(liczba: currency; mpop: byte): currency;

//Operacje na komendach
function comm_getdir(com: string): string;
function comm_getcomm(com: string): string;
function comm_getparam(com: string): string;

implementation

function comm_getdir(com: string): string;
var
  i: byte;
begin
  i := str_findnchar(' ', 1, com);
  //Gdy nie bedzie spacji na koncu
  if i = 0 then
    i := length(com);
  Result := filename2dir(copy(com, 1, i));
end;

function comm_getparam(com: string): string;
var
  i: byte;
begin
  i := str_findnchar(' ', 1, com);
  if i > 0 then
    Result := copy(com, i + 1, length(com) - i)
  else
    Result := '';
end;

function comm_getcomm(com: string): string;
var
  i, len: byte;
begin
  i := str_findnchar(' ', 1, com);
  if i = 0 then
    i := length(com);
  com := copy(com, 1, i);
  len := length(filename2dir(com));
  Result := copy(com, len + 1, i - len);
end;
//Przeksztalca zapis daty na dd.mm.rrrr

function data_getdmr: string;
var
  data: string;
begin
  data := 'Zly format daty';
  data := datetostr(date);
  //03-01-01 win9x/Me - in old systems
  if length(data) = 8 then
    data := '20' + data;
  data := copy(data, 9, 2) + '-' + copy(data, 6, 2) + '-' + copy(data, 1, 4);
  Result := data;
end;

function data_getrmd: string;
var
  data: string;
begin
  data := datetostr(date);
  if length(data) = 8 then
    data := '20' + data;
  Result := data;
end;
//Wyciaga z sciezki do pliku katalog (win i lin)
//Zostawia kreske na koncu

function filename2dir(filename: string): string;
var
  a: char;
  i, z: byte;
begin
  z := length(filename);
  for i := 1 to z do
  begin
    a := filename[z - i - 1];
    if (a = '/') or (a = '\') or (a = '') then
      break;
  end;
  Result := copy(filename, 0, z - i - 1);
end;
//Tworzy plik i zwraca wartosc

function file_create(plik: string): boolean;
begin
  Result := true;
  if filecreate(plik) < 0 then
    Result := false;
end;
//Kopiuje plik

procedure file_copy(plik1, plik2: string);
var
  f1, f2: file of char;
  a: char;
begin
  if (not fileexists(plik1)) or (fileexists(plik2)) then
    exit;
  assignfile(f1, plik1);
  assignfile(f2, plik2);
  filemode := 0;
  reset(f1);
  rewrite(f2);
  repeat
    read(f1, a);
    write(f2, a);
  until eof(f1);
  closefile(f1);
  closefile(f2);
end;

//!! Przed uzyciem otworz plik - czyta linie tekstu z pliku

function myfile_rdln(encoding: byte): string;
var
  str: string;
begin
  str := '';
  readln(myfile, str);
  //Wybor kodowania odczytanych danych
  str := str_encode(str, encoding);
  Result := str;
end;
//Zapisuje pojedyncza linie do pliku tekstowego

procedure myfile_wrln(str: string; encoding: byte);
begin
  //Wybor kodowania zapisywanych danych
  str := str_encode(str, encoding);
  str := str + #13;
  Writeln(myfile, str);
end;
//zwraca wartosc argumentu  w slowie,od 1

function myGetnArg(argumenty: string; numer: integer; seperator: char): string;
var
  odpoz, dopoz: byte;
  s: string;
begin
  s := '';
  if numer > 0 then
  begin
    odpoz := str_findnchar(seperator, numer - 1, argumenty);
    //znaleziono poczatek argumentu
    if (odpoz > 0) or (numer = 1) then
    begin
      inc(odpoz);
      dopoz := str_findnchar(seperator, numer, argumenty);
      //jezeli brak koncowego seperatora to koniec argumentu na koncu slowa
      if dopoz = 0 then
        dopoz := length(argumenty)
      else
        dec(dopoz);
      //brak seperatorow dopuszczalny tylko dla 1 argumentu
      s := copy(argumenty, odpoz, dopoz - odpoz + 1);
    end;
  end;
  myGetnArg := s;
end;

//zastepuje slowo w slowie

function str_repstr(str, strco, strczym: string): string;
var
  i, replen, len: byte;
  sout: string;
begin
  i := 1;
  sout := '';
  len := length(str);
  replen := length(strco);
  //sytuacje anormalne
  if (str = '') or (replen > len) or (strco = '') then
  begin
    Result := '-1';
    exit;
  end;
  repeat
    if copy(str, i, replen) = strco then
    begin
      sout := sout + strczym;
      i := i + replen;
    end
    else
    begin
      sout := sout + str[i];
      inc(i);
    end;
  until i > len;
  Result := sout;
end;
//szuka n-tego znaku w slowie i zwraca jego pozycje, od 1

function str_findnchar(znak: char; n: byte; slowo: string): byte;
var
  i, len, find, wynik: byte;
begin
  find := 1;
  wynik := 0;
  if n > 0 then
  begin
    len := length(slowo);
    for i := 1 to len do
      if slowo[i] = znak then
      begin
        if find = n then
        begin
          wynik := i;
          break;
        end;
        inc(find);
      end;
  end;
  Result := wynik;
end;
//usuwa puste pola(spacja,tab) przed i za slowem

function str_nbespace(slowo: string): string;
var
  i, dl: byte;
begin
  dl := length(slowo);
  for i := 1 to dl do
    if (byte(slowo[i]) <> 32) and (byte(slowo[i]) <> 9) then
      break;
  slowo := copy(slowo, i, dl - i + 1);
  dl := length(slowo);
  for i := 1 to dl do
    if (byte(slowo[dl - i + 1]) <> 32) and (byte(slowo[dl - i + 1]) <> 9) then
      break;
  slowo := copy(slowo, 1, dl - i + 1);
  Result := slowo;
end;
//Konwersja cp1250 do iso8859-2

function str_win2lin(win: string): string;
var
  i, znak: byte;
begin
  for i := 1 to length(win) do
  begin
    znak := byte(win[i]);
    case znak of
      185: win[i] := chr(177);
      165: win[i] := chr(161);
      156: win[i] := chr(182);
      140: win[i] := chr(166);
      159: win[i] := chr(188);
      143: win[i] := chr(172);
    end;
  end;
  Result := win;
end;
//konwersja iso8859-2 do cp1250

function str_lin2win(lin: string): string;
var
  i, znak: byte;
begin
  for i := 1 to length(lin) do
  begin
    znak := byte(lin[i]);
    case znak of
      177: lin[i] := chr(185);
      161: lin[i] := chr(165);
      182: lin[i] := chr(156);
      166: lin[i] := chr(140);
      188: lin[i] := chr(159);
      172: lin[i] := chr(143);
    end;
  end;
  Result := lin;
end;

function str_pl2ps(s: string): string;
var
  i, z: byte;
  s2: string;
begin
  s2 := '';
  for i := 1 to length(s) do
  begin
    z := byte(s[i]);
    case z of
      234: s2 := s2 + '\352';
      202: s2 := s2 + '\312';
      243: s2 := s2 + '\363';
      211: s2 := s2 + '\323';
      177: s2 := s2 + '\261';
      185: s2 := s2 + '\261';
      161: s2 := s2 + '\241';
      165: s2 := s2 + '\241';
      182: s2 := s2 + '\266';
      156: s2 := s2 + '\266';
      166: s2 := s2 + '\246';
      140: s2 := s2 + '\246';
      179: s2 := s2 + '\263';
      163: s2 := s2 + '\243';
      191: s2 := s2 + '\277';
      175: s2 := s2 + '\257';
      188: s2 := s2 + '\274';
      159: s2 := s2 + '\274';
      172: s2 := s2 + '\254';
      143: s2 := s2 + '\254';
      230: s2 := s2 + '\346';
      198: s2 := s2 + '\306';
      241: s2 := s2 + '\361';
      209: s2 := s2 + '\321';
      92: s2 := s2 + '\134';            // "\"
    else
      s2 := s2 + s[i];
    end;
  end;
  Result := s2;
end;
//Zamienia litery na duze (lin i win)

function str_upcase(str: string): string;
var
  i, znak, count: byte;
begin
  count := length(str);
  for i := 1 to count do
  begin
    znak := byte(str[i]);
    //Upcase polnish charset
    case znak of
      177: str[i] := #161;
      185: str[i] := #165;
      230: str[i] := #198;
      234: str[i] := #202;
      179: str[i] := #163;
      241: str[i] := #209;
      243: str[i] := #211;
      182: str[i] := #166;
      156: str[i] := #140;
      188: str[i] := #172;
      159: str[i] := #143;
      191: str[i] := #175;
    end;
    //Upcase a..z
    if (znak > 96) and (znak < 123) then
      str[i] := char(znak - 32);
  end;
  Result := str;
end;
//zmiana kodowania, malych liter

function str_encode(str: string; encoding: byte): string;
begin
  //Wybor kodowania znakow
  case encoding of
    1: str := str_win2lin(str);
    2: str := str_lin2win(str);
    3: str := str_pl2ps(str);
    4: str := str_upcase(str);
    41:
      begin
        str := str_upcase(str);
        str := str_win2lin(str);
      end;
    42:
      begin
        str := str_upcase(str);
        str := str_lin2win(str);
      end;
    43:
      begin
        str := str_upcase(str);
        str := str_pl2ps(str);
      end;
  end;
  Result := str;
end;

function str_delchar(s: string; a: char): string;
var
  i: byte;
  s1: string;
begin
  s1 := '';
  for i := 1 to length(s) do
    if s[i] <> a then
      s1 := s1 + s[i];
  Result := s1;
end;

function str_repchar(s: string; a1, a2: char): string;
var
  i: byte;
begin
  for i := 1 to length(s) do
    if s[i] = a1 then
      s[i] := a2;
  Result := s;
end;

function str_alignr(s: string; dl: byte; dop: char): string;
var
  i, c: byte;
begin
  c := length(s);
  if c < dl then
    for i := 1 to dl - c do
      s := dop + s
  else
    s := copy(s, 1, dl);
  Result := s;
end;

function str_toreal(s: string): currency;
begin
  str_repchar(s, '.', ',');
  if test_float(s) = true then
    Result := strtofloat(s)
  else
    Result := 0;
end;

function str_toint(s: string): integer;
begin
  if (test_int(s) = true) and (s <> '') then
    Result := strtoint(s)
  else
    Result := 0;
end;

function str_fromint(i: integer; lpoz: byte): string;
begin
  if (lpoz > 0) and (i > 0) then
    Result := str_alignr(inttostr(i), lpoz, '0')
  else
    Result := inttostr(i);
end;

function str_tobool(s: string): boolean;
begin
  Result := false;
  if (s = '1') or (str_upcase(s) = 'TRUE') then
    Result := true;
end;
//Sprawdza czy lancuch zawiera liczbe

function test_int(s: string): boolean;
var
  i: byte;
begin
  Result := true;
  if length(s) = 0 then
  begin
    Result := false;
    exit;
  end;
  for i := 1 to length(s) do
    if ((byte(s[i]) < 48) or (byte(s[i]) > 57)) then
    begin
      Result := false;
      break;
    end;
end;
//Sprawdza czy lancuch zawiera liczbe rzeczywista

function test_float(s: string): boolean;
var
  i, z: byte;
  wynik: boolean;
begin
  wynik := true;
  if length(s) = 0 then
  begin
    Result := false;
    exit;
  end;
  for i := 1 to length(s) do
  begin
    z := byte(s[i]);
    if ((z < 48) and (z <> 44)) or (z > 57) then
    begin
      wynik := false;
      break;
    end;
  end;
  Result := wynik;
end;
//Testy urzedowe i liczbowe

function test_pesel(pesel: string): boolean;
begin
  if (length(pesel) = 11) and (test_int(pesel) = true) then
    Result := true
  else
    result := false;
end;

function test_nip(nip: string): boolean;
begin
  if (length(nip) = 10) and (test_int(nip) = true) then
    Result := true
  else
    result := false;
end;

function test_nipr(nipr: string): boolean;
begin
  if (length(nipr) = 19) and (nipr[11] = '*') then
    Result := true
  else
    result := false;
  if nipr = '' then
    Result := true;
end;

function test_kodpocz(kodpocz: string): boolean;
begin
  if (length(kodpocz) = 6) and (kodpocz[3] = '-') then
    Result := true
  else
    result := false;
end;

function test_kwoj(woj: string): boolean;
begin
  if length(woj) = 2 then
    Result := true
  else
    Result := false;
end;

function test_kpow(pow: string): boolean;
begin
  if length(pow) = 4 then
    Result := true
  else
    Result := false;
end;

function test_kgm(gm: string): boolean;
begin
  if length(gm) = 6 then
    Result := true
  else
    Result := false;
end;
//liczbowe

function potega(liczba, potega: word): word;
var
  i, wynik: word;
begin
  wynik := liczba;
  if potega = 0 then
    wynik := 1;
  if potega > 1 then
    for i := 2 to potega do
      wynik := wynik * liczba;
  Result := wynik;
end;

function zaokraglij(liczba: currency; mpop: byte): currency;
var
  pot: word;
begin
  pot := potega(10, mpop);
  Result := round(liczba * pot) / pot;
end;
//Daty

function data_mscname(msc: byte): string;
var
  s: string;
begin
  case msc of
    1: s := 'Stycze';
    2: s := 'Luty';
    3: s := 'Marzec';
    4: s := 'Kwiecie';
    5: s := 'Maj';
    6: s := 'Czerwiec';
    7: s := 'Lipiec';
    8: s := 'Sierpie';
    9: s := 'Wrzesie';
    10: s := 'Padziernik';
    11: s := 'Listopad';
    12: s := 'Grudzie';
  end;
  Result := s;
end;

end.


